/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include <sstream>
#include <limits>

#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4/include/IfcCartesianPoint.h"
#include "ifcpp/IFC4/include/IfcPolyLoop.h"
#include "ifcpp/IFC4/include/IfcPresentationLayerAssignment.h"
#include "ifcpp/IFC4/include/IfcStyledItem.h"

// ENTITY IfcPolyLoop 
IfcPolyLoop::IfcPolyLoop( int id ) { m_entity_id = id; }
IfcPolyLoop::~IfcPolyLoop() {}
shared_ptr<BuildingObject> IfcPolyLoop::getDeepCopy( BuildingCopyOptions& options )
{
	shared_ptr<IfcPolyLoop> copy_self( new IfcPolyLoop() );
	for( size_t ii=0; ii<m_Polygon.size(); ++ii )
	{
		auto item_ii = m_Polygon[ii];
		if( item_ii )
		{
			copy_self->m_Polygon.emplace_back( dynamic_pointer_cast<IfcCartesianPoint>(item_ii->getDeepCopy(options) ) );
		}
	}
	return copy_self;
}
void IfcPolyLoop::getStepLine( std::stringstream& stream ) const
{
	stream << "#" << m_entity_id << "= IFCPOLYLOOP" << "(";
	writeEntityList( stream, m_Polygon );
	stream << ");";
}
void IfcPolyLoop::getStepParameter( std::stringstream& stream, bool ) const { stream << "#" << m_entity_id; }
const std::wstring IfcPolyLoop::toString() const { return L"IfcPolyLoop"; }
void IfcPolyLoop::readStepArguments( const std::vector<std::wstring>& args, const std::map<int,shared_ptr<BuildingEntity> >& map )
{
	const size_t num_args = args.size();
	if( num_args != 1 ){ std::stringstream err; err << "Wrong parameter count for entity IfcPolyLoop, expecting 1, having " << num_args << ". Entity ID: " << m_entity_id << std::endl; throw BuildingException( err.str().c_str() ); }
	readEntityReferenceList( args[0], m_Polygon, map );
}
void IfcPolyLoop::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IfcLoop::getAttributes( vec_attributes );
	if( !m_Polygon.empty() )
	{
		shared_ptr<AttributeObjectVector> Polygon_vec_object( new AttributeObjectVector() );
		std::copy( m_Polygon.begin(), m_Polygon.end(), std::back_inserter( Polygon_vec_object->m_vec ) );
		vec_attributes.emplace_back( std::make_pair( "Polygon", Polygon_vec_object ) );
	}
}
void IfcPolyLoop::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IfcLoop::getAttributesInverse( vec_attributes_inverse );
}
void IfcPolyLoop::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcLoop::setInverseCounterparts( ptr_self_entity );
}
void IfcPolyLoop::unlinkFromInverseCounterparts()
{
	IfcLoop::unlinkFromInverseCounterparts();
}
