/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include <sstream>
#include <limits>

#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4/include/IfcCartesianPoint.h"
#include "ifcpp/IFC4/include/IfcPolyline.h"
#include "ifcpp/IFC4/include/IfcPresentationLayerAssignment.h"
#include "ifcpp/IFC4/include/IfcStyledItem.h"

// ENTITY IfcPolyline 
IfcPolyline::IfcPolyline( int id ) { m_entity_id = id; }
IfcPolyline::~IfcPolyline() {}
shared_ptr<BuildingObject> IfcPolyline::getDeepCopy( BuildingCopyOptions& options )
{
	shared_ptr<IfcPolyline> copy_self( new IfcPolyline() );
	for( size_t ii=0; ii<m_Points.size(); ++ii )
	{
		auto item_ii = m_Points[ii];
		if( item_ii )
		{
			copy_self->m_Points.emplace_back( dynamic_pointer_cast<IfcCartesianPoint>(item_ii->getDeepCopy(options) ) );
		}
	}
	return copy_self;
}
void IfcPolyline::getStepLine( std::stringstream& stream ) const
{
	stream << "#" << m_entity_id << "= IFCPOLYLINE" << "(";
	writeEntityList( stream, m_Points );
	stream << ");";
}
void IfcPolyline::getStepParameter( std::stringstream& stream, bool ) const { stream << "#" << m_entity_id; }
const std::wstring IfcPolyline::toString() const { return L"IfcPolyline"; }
void IfcPolyline::readStepArguments( const std::vector<std::wstring>& args, const std::map<int,shared_ptr<BuildingEntity> >& map )
{
	const size_t num_args = args.size();
	if( num_args != 1 ){ std::stringstream err; err << "Wrong parameter count for entity IfcPolyline, expecting 1, having " << num_args << ". Entity ID: " << m_entity_id << std::endl; throw BuildingException( err.str().c_str() ); }
	readEntityReferenceList( args[0], m_Points, map );
}
void IfcPolyline::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IfcBoundedCurve::getAttributes( vec_attributes );
	if( !m_Points.empty() )
	{
		shared_ptr<AttributeObjectVector> Points_vec_object( new AttributeObjectVector() );
		std::copy( m_Points.begin(), m_Points.end(), std::back_inserter( Points_vec_object->m_vec ) );
		vec_attributes.emplace_back( std::make_pair( "Points", Points_vec_object ) );
	}
}
void IfcPolyline::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IfcBoundedCurve::getAttributesInverse( vec_attributes_inverse );
}
void IfcPolyline::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcBoundedCurve::setInverseCounterparts( ptr_self_entity );
}
void IfcPolyline::unlinkFromInverseCounterparts()
{
	IfcBoundedCurve::unlinkFromInverseCounterparts();
}
