/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include <sstream>
#include <limits>

#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4/include/IfcGloballyUniqueId.h"
#include "ifcpp/IFC4/include/IfcIdentifier.h"
#include "ifcpp/IFC4/include/IfcLabel.h"
#include "ifcpp/IFC4/include/IfcOwnerHistory.h"
#include "ifcpp/IFC4/include/IfcRelAggregates.h"
#include "ifcpp/IFC4/include/IfcRelAssigns.h"
#include "ifcpp/IFC4/include/IfcRelAssignsToControl.h"
#include "ifcpp/IFC4/include/IfcRelAssociates.h"
#include "ifcpp/IFC4/include/IfcRelDeclares.h"
#include "ifcpp/IFC4/include/IfcRelDefinesByObject.h"
#include "ifcpp/IFC4/include/IfcRelDefinesByProperties.h"
#include "ifcpp/IFC4/include/IfcRelDefinesByType.h"
#include "ifcpp/IFC4/include/IfcRelNests.h"
#include "ifcpp/IFC4/include/IfcText.h"
#include "ifcpp/IFC4/include/IfcWorkCalendar.h"
#include "ifcpp/IFC4/include/IfcWorkCalendarTypeEnum.h"
#include "ifcpp/IFC4/include/IfcWorkTime.h"

// ENTITY IfcWorkCalendar 
IfcWorkCalendar::IfcWorkCalendar( int id ) { m_entity_id = id; }
IfcWorkCalendar::~IfcWorkCalendar() {}
shared_ptr<BuildingObject> IfcWorkCalendar::getDeepCopy( BuildingCopyOptions& options )
{
	shared_ptr<IfcWorkCalendar> copy_self( new IfcWorkCalendar() );
	if( m_GlobalId )
	{
		if( options.create_new_IfcGloballyUniqueId ) { copy_self->m_GlobalId = make_shared<IfcGloballyUniqueId>( createBase64Uuid<wchar_t>().data() ); }
		else { copy_self->m_GlobalId = dynamic_pointer_cast<IfcGloballyUniqueId>( m_GlobalId->getDeepCopy(options) ); }
	}
	if( m_OwnerHistory )
	{
		if( options.shallow_copy_IfcOwnerHistory ) { copy_self->m_OwnerHistory = m_OwnerHistory; }
		else { copy_self->m_OwnerHistory = dynamic_pointer_cast<IfcOwnerHistory>( m_OwnerHistory->getDeepCopy(options) ); }
	}
	if( m_Name ) { copy_self->m_Name = dynamic_pointer_cast<IfcLabel>( m_Name->getDeepCopy(options) ); }
	if( m_Description ) { copy_self->m_Description = dynamic_pointer_cast<IfcText>( m_Description->getDeepCopy(options) ); }
	if( m_ObjectType ) { copy_self->m_ObjectType = dynamic_pointer_cast<IfcLabel>( m_ObjectType->getDeepCopy(options) ); }
	if( m_Identification ) { copy_self->m_Identification = dynamic_pointer_cast<IfcIdentifier>( m_Identification->getDeepCopy(options) ); }
	for( size_t ii=0; ii<m_WorkingTimes.size(); ++ii )
	{
		auto item_ii = m_WorkingTimes[ii];
		if( item_ii )
		{
			copy_self->m_WorkingTimes.emplace_back( dynamic_pointer_cast<IfcWorkTime>(item_ii->getDeepCopy(options) ) );
		}
	}
	for( size_t ii=0; ii<m_ExceptionTimes.size(); ++ii )
	{
		auto item_ii = m_ExceptionTimes[ii];
		if( item_ii )
		{
			copy_self->m_ExceptionTimes.emplace_back( dynamic_pointer_cast<IfcWorkTime>(item_ii->getDeepCopy(options) ) );
		}
	}
	if( m_PredefinedType ) { copy_self->m_PredefinedType = dynamic_pointer_cast<IfcWorkCalendarTypeEnum>( m_PredefinedType->getDeepCopy(options) ); }
	return copy_self;
}
void IfcWorkCalendar::getStepLine( std::stringstream& stream ) const
{
	stream << "#" << m_entity_id << "= IFCWORKCALENDAR" << "(";
	if( m_GlobalId ) { m_GlobalId->getStepParameter( stream ); } else { stream << "$"; }
	stream << ",";
	if( m_OwnerHistory ) { stream << "#" << m_OwnerHistory->m_entity_id; } else { stream << "$"; }
	stream << ",";
	if( m_Name ) { m_Name->getStepParameter( stream ); } else { stream << "$"; }
	stream << ",";
	if( m_Description ) { m_Description->getStepParameter( stream ); } else { stream << "$"; }
	stream << ",";
	if( m_ObjectType ) { m_ObjectType->getStepParameter( stream ); } else { stream << "$"; }
	stream << ",";
	if( m_Identification ) { m_Identification->getStepParameter( stream ); } else { stream << "$"; }
	stream << ",";
	writeEntityList( stream, m_WorkingTimes );
	stream << ",";
	writeEntityList( stream, m_ExceptionTimes );
	stream << ",";
	if( m_PredefinedType ) { m_PredefinedType->getStepParameter( stream ); } else { stream << "$"; }
	stream << ");";
}
void IfcWorkCalendar::getStepParameter( std::stringstream& stream, bool ) const { stream << "#" << m_entity_id; }
const std::wstring IfcWorkCalendar::toString() const { return L"IfcWorkCalendar"; }
void IfcWorkCalendar::readStepArguments( const std::vector<std::wstring>& args, const std::map<int,shared_ptr<BuildingEntity> >& map )
{
	const size_t num_args = args.size();
	if( num_args != 9 ){ std::stringstream err; err << "Wrong parameter count for entity IfcWorkCalendar, expecting 9, having " << num_args << ". Entity ID: " << m_entity_id << std::endl; throw BuildingException( err.str().c_str() ); }
	m_GlobalId = IfcGloballyUniqueId::createObjectFromSTEP( args[0], map );
	readEntityReference( args[1], m_OwnerHistory, map );
	m_Name = IfcLabel::createObjectFromSTEP( args[2], map );
	m_Description = IfcText::createObjectFromSTEP( args[3], map );
	m_ObjectType = IfcLabel::createObjectFromSTEP( args[4], map );
	m_Identification = IfcIdentifier::createObjectFromSTEP( args[5], map );
	readEntityReferenceList( args[6], m_WorkingTimes, map );
	readEntityReferenceList( args[7], m_ExceptionTimes, map );
	m_PredefinedType = IfcWorkCalendarTypeEnum::createObjectFromSTEP( args[8], map );
}
void IfcWorkCalendar::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IfcControl::getAttributes( vec_attributes );
	if( !m_WorkingTimes.empty() )
	{
		shared_ptr<AttributeObjectVector> WorkingTimes_vec_object( new AttributeObjectVector() );
		std::copy( m_WorkingTimes.begin(), m_WorkingTimes.end(), std::back_inserter( WorkingTimes_vec_object->m_vec ) );
		vec_attributes.emplace_back( std::make_pair( "WorkingTimes", WorkingTimes_vec_object ) );
	}
	if( !m_ExceptionTimes.empty() )
	{
		shared_ptr<AttributeObjectVector> ExceptionTimes_vec_object( new AttributeObjectVector() );
		std::copy( m_ExceptionTimes.begin(), m_ExceptionTimes.end(), std::back_inserter( ExceptionTimes_vec_object->m_vec ) );
		vec_attributes.emplace_back( std::make_pair( "ExceptionTimes", ExceptionTimes_vec_object ) );
	}
	vec_attributes.emplace_back( std::make_pair( "PredefinedType", m_PredefinedType ) );
}
void IfcWorkCalendar::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IfcControl::getAttributesInverse( vec_attributes_inverse );
}
void IfcWorkCalendar::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcControl::setInverseCounterparts( ptr_self_entity );
}
void IfcWorkCalendar::unlinkFromInverseCounterparts()
{
	IfcControl::unlinkFromInverseCounterparts();
}
